import 'package:flutter/material.dart';

import 'package:sudoku/entities/cell.dart';
import 'package:sudoku/provider/data.dart';

class Board {
  static Container buildGameBoard(Data myProvider) {
    const Color borderColor = Colors.black;

    return Container(
      margin: const EdgeInsets.all(2),
      padding: const EdgeInsets.all(2),
      decoration: BoxDecoration(
        color: borderColor,
        borderRadius: BorderRadius.circular(2),
        border: Border.all(
          color: borderColor,
          width: 2,
        ),
      ),
      child: Column(
        children: [
          buildGameTileset(myProvider),
        ],
      ),
    );
  }

  static Widget buildGameTileset(Data myProvider) {
    final int boardSize = myProvider.blockSizeHorizontal * myProvider.blockSizeVertical;
    final List<List<Cell>> cells = myProvider.cells;

    return Table(defaultColumnWidth: const IntrinsicColumnWidth(), children: [
      for (int row = 0; row < boardSize; row++)
        TableRow(children: [
          for (int col = 0; col < boardSize; col++)
            Column(children: [cells[row][col].widget(myProvider, row, col)]),
        ]),
    ]);
  }
}
